<template>
  <v-container fill-height>
    <v-row align="center" justify="center">
      <v-card v-if="!isConnected" color="red " class="mx-auto" width="90%">
        <v-card-text>
          <p class="display-1 text--primary text-center">
            Server connection failed.
            <br />Please contact support.
          </p>
        </v-card-text>
      </v-card>
      <v-card v-else color="indigo " class="mx-auto" width="90%">
        <template v-if="shutdownTrigger">
          <v-card-text>
            <p class="display-5 text--primary">WVD shutdown in</p>
            <p class="display-1 text--primary">{{timer}}</p>
            <div class="text--primary">
              <p>{{shutdownMessage}}</p>
              <p>We will ask you 10 minutes before the shutdown time.</p>
            </div>
          </v-card-text>
          <v-card-actions>
            <v-btn color="orange" @click.stop="postponeDialog = true">Postpone</v-btn>
            <v-spacer></v-spacer>
            <v-btn color="grey lighten-1" @click.stop="cofirmShutdown">Hide</v-btn>
          </v-card-actions>
        </template>
        <template v-else>
          <v-card-text>
            <p class="display-1 text--red text-center">
              Trigger data not found.
              <br />Please contact support.
            </p>
          </v-card-text>
        </template>
      </v-card>
    </v-row>

    <v-dialog v-model="postponeDialog" max-width="500">
      <v-card>
        <v-card-title class="headline">Postpone Shutdown</v-card-title>

        <v-card-text>We will ask you again 10 minutes before.</v-card-text>

        <v-card-actions>
          <v-btn color="green darken-1" text @click="postponeShutdown(1)">1 Hour</v-btn>
          <v-btn color="green darken-1" text @click="postponeShutdown(2)">2 Hours</v-btn>
          <v-btn color="green darken-1" text @click="postponeShutdown(3)">3 Hours</v-btn>
          <v-btn color="red darken-1" text @click="skipShutdown">1 Day</v-btn>
          <v-spacer></v-spacer>
          <v-btn color="white darken-1" text @click="postponeDialog = false">Cancel</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <v-overlay :value="overlay" z-index="1000">
      <v-progress-circular indeterminate size="64"></v-progress-circular>
    </v-overlay>
  </v-container>
</template>

<script>
import moment from 'moment';
// import axios from '@/plugins/axios';
import axios from 'axios';
const { ipcRenderer } = require('electron');

export default {
  name: 'Home',
  data: () => ({
    // vm: {},
    shutdownTrigger: null,
    postponeDialog: false,
    devicename: '',
    currentuser: '',
    timer: null,
    isConnected: false,
    overlay: false,
  }),
  computed: {
    shutdownMessage() {
      if (!this.shutdownTrigger) {
        return '';
      }
      var shutdownTime = moment.utc(this.shutdownTrigger.trigger_at).local();
      var dateString = shutdownTime.isSame(new Date(), 'day')
        ? 'today'
        : shutdownTime.format('dddd, Do MMM');
      var timeString = shutdownTime.format('hh:mm a');
      return `Your PC is scheduled to shutdown ${dateString} at ${timeString}`;
    },
  },
  mounted() {
    this.devicename = ipcRenderer.sendSync('get-devicename');
    this.currentuser = ipcRenderer.sendSync('get-username');
    this.setupVmData()
      .then((response) => {
        console.log('Trigger recieved');
        setInterval(() => {
          this.remainingTime();
        }, 1000);
        ipcRenderer.on('reset-trigger', this.resetShutdownTrigger);
        this.subscribeToChannel();
        this.activateEvents();
        this.isConnected =
          window.Echo.connector.pusher.connection.state === 'connected';
      })
      .catch((err) => {
        console.log('Trigger not recieved');
        console.log(err);
      });
  },
  beforeDestroy() {
    window.Echo.leave(`wvd.${this.devicename}`);
  },
  methods: {
    remainingTime() {
      var shutdownTime = moment.utc(this.shutdownTrigger.trigger_at).local();
      var duration = moment.duration(shutdownTime.diff(moment()));
      // console.log(shutdownTime);
      var str = [];

      if (duration.days(true) > 0) {
        str.push(`${duration.days(true)} Days`);
      }

      if (duration.hours(true) > 0) {
        str.push(`${duration.hours(true)} Hours`);
      }

      if (duration.minutes(true) > 0) {
        str.push(`${duration.minutes(true)} Minutes`);
      }

      if (duration.seconds() > 0) {
        str.push(`${duration.seconds(true)} Seconds`);
      }

      if (str.length > 0) {
        // return 'Shutdown in ' + str.join(' and ');
        this.timer = str.join(' and ');
      } else {
        this.timer = '';
      }
    },
    loader(show = true) {
      this.overlay = show;
    },
    async setupVmData() {
      this.loader();
      try {
        var vmData = await axios.post(`trigger/${this.devicename}`, {
          last_user: this.currentuser,
        });
        if (vmData.data.data == null) {
          console.error('No trigger data provided by server.');
          throw new Error('No trigger data provided by server.');
        }
        this.shutdownTrigger = vmData.data.data;
        this.loader(false);
        return Promise.resolve(vmData.data);
      } catch (err) {
        this.loader(false);
        this.$dialog.error({
          title: 'No Trigger Data',
          text: 'Please contaact support.',
        });
        throw err;
      }
    },
    hideWindow() {
      ipcRenderer.sendSync('hide-window');
    },
    async skipShutdown() {
      var userResponse = await this.$dialog.warning({
        text: 'Are you sure to postpone shutdown for 1 day?',
        title: 'Are you sure?',
        persistent: false,
      });
      if (!userResponse) {
        return false;
      }
      this.loader();
      return axios
        .post(`trigger/${this.shutdownTrigger.uid}/skip`, {
          days: '1',
        })
        .then((res) => {
          this.loader(false);
          this.shutdownTrigger = res.data.data;
          this.postponeDialog = false;
          this.handleGoodResponse(res.data);
        })
        .catch((err) => {
          this.loader(false);
          this.handleBadResponse(err);
        });
    },
    async resetShutdownTrigger() {
      var userResponse = await this.$dialog.warning({
        text: 'Are you sure to reset the schedule to default?',
        title: 'Are you sure?',
        persistent: false,
      });
      if (!userResponse) {
        return false;
      }
      this.loader();
      return axios
        .post(`trigger/${this.shutdownTrigger.uid}/reset`)
        .then((res) => {
          this.loader(false);
          this.shutdownTrigger = res.data.data;
          this.handleGoodResponse(res.data);
        })
        .catch((err) => {
          this.loader(false);
          this.handleBadResponse(err);
        });
    },
    cofirmShutdown() {
      this.loader();
      return axios
        .post(`trigger/${this.shutdownTrigger.uid}/confirm`)
        .then((res) => {
          this.loader(false);
          this.shutdownTrigger = res.data.data;
          ipcRenderer.sendSync('hide-window');
          this.handleGoodResponse(res.data);
        })
        .catch((err) => {
          this.loader(false);
          this.handleBadResponse(err);
        });
    },
    async postponeShutdown(hours) {
      var userResponse = await this.$dialog.warning({
        text: `Are you sure to postpone shutdown for ${hours} hours?`,
        title: 'Are you sure?',
        persistent: false,
      });
      console.log(userResponse);
      if (!userResponse) {
        return userResponse;
      }
      this.loader();
      return axios
        .post(`trigger/${this.shutdownTrigger.uid}/postpone`, {
          hours: hours,
        })
        .then((res) => {
          this.loader(false);
          this.postponeDialog = false;
          this.shutdownTrigger = res.data.data;
          this.handleGoodResponse(res.data);
        })
        .catch((err) => {
          this.loader(false);
          this.handleBadResponse(err);
        });
    },
    handleGoodResponse(data) {
      this.$dialog.message.info(data.message);
      setTimeout(() => {
        this.hideWindow();
      }, 2000);
    },
    handleBadResponse(err) {
      const dialogInstance = this.$dialog.error({
        title: 'Error',
        text: 'Something went wrong.',
        waitForResult: false,
      });
      setTimeout(() => {
        dialogInstance.close();
      }, 3000);
      console.error(err);
    },
    activateEvents() {
      window.Echo.connector.pusher.connection.bind('state_change', (state) => {
        console.log(state.current);
        setTimeout(() => {
          if (state.current === 'connected') {
            this.isConnected = true;
          } else {
            ipcRenderer.sendSync('show-window', state);
            this.isConnected = false;
          }
        }, 1000);
      });
    },
    subscribeToChannel() {
      var devicename = this.devicename.toLowerCase();
      window.Echo.channel(`wvd.${devicename}`)
        .listen('ShutDownNotification', (event) => {
          this.setupVmData();
          ipcRenderer.sendSync('show-window');
        })
        .listen('RefreshTriggerDataEvent', (event) => {
          this.setupVmData();
        });
    },
  },
};
</script>
